from wdmmg.tests import *

import wdmmg.model as model

class TestEntryController(TestController):
    @classmethod
    def setup_class(self):
        Fixtures.setup()
    
    @classmethod
    def teardown_class(self):
        Fixtures.teardown()

    def test_index(self):
        response = self.app.get(url(controller='entry', action='index'))
        assert '36 entries' in response, response

    def test_view(self):
        t = model.Session.query(model.Entry).first()
        response = self.app.get(url(controller='entry', action='view', id_=t.id))
        assert '''cra''' in response

    def test_foi(self):
        t = model.Session.query(model.Entry).first()
        response = self.app.get(url(controller='entry', action='view', id_=t.id))
        # For now, just check we AREN'T showing the FOI screen on CRA pages.
        # TODO: more detailed testing.
        assert not '''Make an FOI request''' in response

